package bookExamples.ch15Streams;

import futils.DirList;
import futils.Futil;
import futils.WildFilter;
import gui.In;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.zip.ZipEntry;
import java.util.zip.ZipOutputStream;

/**
 * DocJava, Inc.
 * http://www.docjava.com
 * Programmer: dlyon
 * Date: Sep 22, 2004
 * Time: 7:20:01 PM
 */
public class Zipper {
    public static void main(String[] args) {
        zipDirectory();
        In.message("done");
    }

    private static void zipDirectory() {
        Futil.setSwing(false);
        File outputFile = Futil.getWriteFile("select an output zipFile");
        File dir = Futil.getReadFileDir("select a start point");
        DirList dl = new DirList(dir,new WildFilter(".java"));
        File f[] = dl.getFilesNotDirectories();
        try {
            writeZipFiles(outputFile, f);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public static void writeZipFiles(File outputFile, File filesToBeWritten[])
            throws IOException {
        ZipOutputStream zos = new ZipOutputStream(new FileOutputStream(outputFile));
        zos.setMethod(ZipOutputStream.DEFLATED);
        for (int i = 0; i < filesToBeWritten.length; i++)
            putEntry(filesToBeWritten[i], zos);
        zos.close();
    }

    private static void putEntry(File inputFile, ZipOutputStream zos) throws IOException {
        zos.putNextEntry(new ZipEntry(inputFile.getAbsolutePath()));
        zos.write(Futil.getBytes(inputFile));
        zos.closeEntry();
    }
}
 /*   public static FileStore[] readZipFiles(File inputFile)
            throws IOException {
        ZipFile zf = new ZipFile(inputFile);
        Vector fileStoreVector = new Vector();
        Enumeration e = zf.entries();
        while (e.hasMoreElements()) {
            ZipEntry ze = (ZipEntry) e.nextElement();
            String name = ze.getName();
            if (ze.isDirectory()) continue;
            InputStream is = zf.getInputStream(ze);
            int i = is.available();
            byte b[] = new byte[i];
            is.read(b);
            FileStore fs = new FileStore(new File(name), b);
            fileStoreVector.addElement(fs);
        }
        zf.close();
        return null;// todo not done yet....
    }
*/